/* 
 *  This program is an interactive FAQ to ease investigations.
 *  Copyright (C) 2012 Julien Bruguier.
 * 
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 * 
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 * 
 *     You should have received a copy of the GNU General Public License
 *     along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */ 

#ifndef __INVESTIGATION_DONNEES_SELECTIONREPONSE__
#define __INVESTIGATION_DONNEES_SELECTIONREPONSE__

#include <vector>
#include <src/global/global.h>
namespace Investigation { namespace Donnees { DECL_SHARED_PTR(SelectionReponse); } }
#include <src/investigation/donnees/html.h>
#include <src/investigation/donnees/question.h>
#include <src/investigation/donnees/selection.h>

namespace Investigation
{
	namespace Donnees
	{
		class CompteursSite;
		class SelectionReponse : public Reponse, public Selection<Reponse>
		{
			public:
				SelectionReponse(const typename Selection<Reponse>::SequenceClauses& clauses, const SequenceReponses& clause_par_defaut);
				virtual ~SelectionReponse();
				virtual Html::SequenceLi operator() (const std::string& methode, const Requete& requete, Liens& liens) const;
				virtual ReponseSP clone() const;
				virtual std::set<std::string> operator[] (const Requete& requete);
				virtual bool operator%(const Reponse& reponse) const;
				bool operator%(const SelectionReponse& reponse) const;
				virtual void liens_valides(const std::set<std::string>& identifiants) const;
				virtual void propage_infos(const std::string& page, const std::string& question);
				virtual void compte(CompteursSite& compteurs) const;
			private:
				explicit SelectionReponse(const Selection<Reponse>& selection);
		};
	}
}
#endif
